import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.*;

public class ZeichenBlatt  extends Actor
{
    
    Color c;
    int P[][] = {{1,1,-1},{-1,1,-1},{-1,-1,-1},{1,-1,-1},{1,1,0},{-1,1,0},{-1,-1,0},{1,-1,0},{1,0,1},{-1,0,1}};
    int[] px = new int[10];
    int[] py = new int[10];
    int     e     = 100;            
    int     alpha = 0; 
    int     beta  = 0;
    double  a;    
    double  b;
    int     Mx = 320; 
    int     My = 240;
    public ZeichenBlatt() {
        GreenfootImage img = new GreenfootImage(640,480);
        setImage(img);
        img.setColor(Color.BLACK); 
        img.fill();
    }

    public void act() {
        GreenfootImage img = getImage();
        img.clear();
        img.setColor(Color.BLACK); 
        img.fill();
        alpha++;
        beta=10;
        for(int i=0; i<10; i++) {
            px[i] = toPx(P[i], alpha, beta);
            py[i] = toPy(P[i], alpha, beta);
        }

        img.setColor(Color.YELLOW);
        img.drawPolygon(px, py, 4);

        img.drawLine(px[0], py[0], px[4], py[4]);
        img.drawLine(px[1], py[1], px[5], py[5]);
        img.drawLine(px[2], py[2], px[6], py[6]);
        img.drawLine(px[3], py[3], px[7], py[7]);
        img.drawLine(px[4], py[4], px[5], py[5]);
        img.drawLine(px[5], py[5], px[6], py[6]);
        img.drawLine(px[6], py[6], px[7], py[7]);
        img.drawLine(px[7], py[7], px[4], py[4]);
        img.drawLine(px[8], py[8], px[7], py[7]);
        img.drawLine(px[8], py[8], px[4], py[4]);
        img.drawLine(px[9], py[9], px[5], py[5]);
        img.drawLine(px[9], py[9], px[6], py[6]);

        img.drawLine(px[9], py[9], px[8], py[8]);
    } 

    public int toPx(int A[], int alpha, int beta) {
        double a = Math.toRadians(alpha);
        double b = Math.toRadians(beta);
        double x = Mx+e*A[1]*Math.cos(b)-e*A[0]*Math.sin(b);
        return (int)Math.round(x);
    }

    public int toPy(int A[], int alpha, int beta) {
        double a = Math.toRadians(alpha);
        double b = Math.toRadians(beta);
        double y = My-e*A[2]*Math.cos(a)+e*A[0]*Math.sin(a)*Math.cos(b)+e*A[1]*Math.sin(a)*Math.sin(b);
        return (int)Math.round(y);
    }
}
